moDraw.bestPrice = {};

function moDraw.bestPrice:setOpenPDA(self)
	setTextBold(true);
	local farmSilo = moDefault.multiFarmSilo;
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[moGuiMiniPDAsetGet.slotOpen];	
	local posBbestPrice = moSetGetGui.pdaMenueSize/3*(moDefault.lengthStationName+9+moSetGetGui.screenAspectRatio)*1.03;
	local posBFruit = moSetGetGui.pdaMenueSize/3*(moDefault.lengthFruitName+4+moSetGetGui.screenAspectRatio)*1.03;	
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if tonumber(openSwitchStatus) == 3 then
		posBbestPrice = moSetGetGui.pdaMenueSize/3*(moDefault.lengthStationName+9+moSetGetGui.screenAspectRatio)*1.03; --1.000.000.000 Milliarde
		posBFruit = moSetGetGui.pdaMenueSize/3*(moDefault.lengthFruitName+7+moSetGetGui.screenAspectRatio)*1.03;
		--posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-(posBbestPrice+posBFruit);
	end;
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-(posBbestPrice+posBFruit);end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);
	local firstLetter = 0.003;
	moSetGetGui["designGround"]:render();
	function nextLine(posNew, setLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBbestPrice+posBFruit-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);		
	end;	
	function setInternBestPrice(bestPrice, k)		
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		setTextBold(true);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil and moFillTypes[k].siloAmount[farmSilo] <= 1 then setTextColor(unpack(moGuiMiniPDAsetGet.inactiveColor));noAmount = true;setTextBold(false);end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));
			renderText(posX, firstPosXY, moSetGetGui.pdaMenueSize, "!".. moFillTypes[k].descName); ---old 0.232
		else
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].fruitName);
		end;
		setTextBold(true);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.priceColor));
		local greatDemand = false;
		if moDefault.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPDAsetGet.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;
		renderText(posX+(posBFruit+posBbestPrice/12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, bestPriceTemp);				
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
		if greatDemand then 
			renderText(posX+(posBFruit+posBbestPrice/7)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].greatDemandStation);
		else
			renderText(posX+(posBFruit+posBbestPrice/7)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].bestPriceStation);
		end;
		setTextAlignment(false);		
		nextLine(0.005, true);
	end;
	local bestPriceTotal = 0;
	function setInternBestPriceTotal(bestPrice, k)		
		local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(k);
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		setTextBold(true);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil then
			if moFillTypes[k].siloAmount[farmSilo] <= 1 then 
				setTextColor(unpack(moGuiMiniPDAsetGet.inactiveColor));
				setTextBold(false);
				bestPriceTemp = string.format("%.1f", 0.0);
				noAmount = true;
			else				
				local total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]/1000))/1000;
				bestPriceTotal = bestPriceTotal+total;
				bestPriceTemp = string.format("%.3f", total);
				bestPriceTemp = moGuiExtras:getMoneyFormat(bestPriceTemp);
			end;
		end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));
			renderText(posX, firstPosXY, moSetGetGui.pdaMenueSize, "!".. moFillTypes[k].descName); ---old 0.232
		else
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].fruitName);
		end;
		setTextBold(true);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.priceColor));
		local greatDemand = false;
		if moDefault.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPDAsetGet.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;		
		renderText(posX+(posBFruit+posBbestPrice/12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, bestPriceTemp.. " €");				
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
		if greatDemand then 
			renderText(posX+(posBFruit+posBbestPrice/7)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].greatDemandStation);
		else
			renderText(posX+(posBFruit+posBbestPrice/7)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moFillTypes[k].bestPriceStation);
		end;
		setTextAlignment(false);		
		nextLine(0.005, true);
	end;
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));			
	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['bestPrice'.. moDefault.language]));	
	nextLine(0.005, true);	
	moSortBestPrice = {};	
	local count = 0;
	for k,v in pairs(moFillTypes) do			
		if Fillable.fillTypeIndexToDesc[k].partOfEconomy ~= nil and Fillable.fillTypeIndexToDesc[k].partOfEconomy or moFillTypes[k].descName == "silage" then --or moFillTypes[k].descName == "wool" or moFillTypes[k].descName == "milk" or moFillTypes[k].descName == "egg" then
			if string.len(moFillTypes[k].bestPriceStation) >= 2 then
				local bestPrice = 0;
				if moFillTypes[k].greatDemandStationDescName ~= nil then
					bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moDefault.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
				else					
					bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].bestPrice*moDefault.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;					
				end;
				if string.find(moDefault.foundAnimals, moFillTypes[k].descName.. " ") then	
					if moFillTypes[k].greatDemandStationDescName ~= nil then
						bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moDefault.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
					else						
						bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moDefault.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;						
					end;
				end;				
				--if string.find(moDefault.foundAnimals, moFillTypes[k].descName.. " ") or moFillTypes[k].descName == "beef" or moFillTypes[k].descName == "pig" or moFillTypes[k].descName == "chicken2" or moFillTypes[k].descName == "cow" or moFillTypes[k].descName == "sheep" or moFillTypes[k].descName == "chicken" then								
				--	bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moDefault.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
				--end;
				--local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));				
				if tonumber(openSwitchStatus) == 2 then
					count = count+1;					
					moSortBestPrice[count] = (bestPrice/1000).. ";".. k;					
				elseif tonumber(openSwitchStatus) == 3 then				
					setInternBestPriceTotal(bestPrice, k);
				else
					setInternBestPrice(bestPrice, k);
				end;							
			end;			
		end;
	end;
	if tonumber(openSwitchStatus) == 2 and count > 0 then
		function comp(w1,w2)
			if w1 > w2 then
				return true
			end
		end		
		table.sort(moSortBestPrice, comp);		
		for a=1, table.getn(moSortBestPrice) do
			local priceDesc = Utils.splitString(";", moSortBestPrice[a]);			
			if priceDesc ~= nil and priceDesc[1] ~= nil and priceDesc[2] ~= nil then				
				setInternBestPrice(priceDesc[1]*1000, tonumber(priceDesc[2]));
			end;
		end;
	end;
	if tonumber(openSwitchStatus) == 3 then		
		setTextBold(true);
		local bestPriceTemp = string.format("%.3f", bestPriceTotal);
		bestPriceTemp = moGuiExtras:getMoneyFormat(bestPriceTemp);		
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));		
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "Total:");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		renderText(posX+(posBFruit+posBbestPrice/12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, bestPriceTemp.. " €");
		setTextAlignment(false);		
		nextLine(0.005, true);
	end;
	--renderOverlay(self.MultiOverlayDesignGround, posX-0.001, posY, posBbestPrice+posBFruit+firstLetter, posH);
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-firstLetter, posY, posBbestPrice+posBFruit-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBbestPrice+posBFruit-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;
	setTextBold(false);
end;